searchNodes=[{"ref":"Mix.Tasks.PhoenixRest.Gen.Resource.html","title":"Mix.Tasks.PhoenixRest.Gen.Resource","type":"task","doc":"Generates a PlugRest resource in your Phoenix application. mix phoenix_rest.gen.resource UserResource The generated resource will contain: a resource file in web/resources"},{"ref":"Mix.Tasks.PhoenixRest.Gen.Resource.html#no_umbrella!/1","title":"Mix.Tasks.PhoenixRest.Gen.Resource.no_umbrella!/1","type":"function","doc":"Raises on umbrella application."},{"ref":"Mix.Tasks.PhoenixRest.Gen.Resource.html#run/1","title":"Mix.Tasks.PhoenixRest.Gen.Resource.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Mix.Tasks.PhxRest.Gen.Resource.html","title":"Mix.Tasks.PhxRest.Gen.Resource","type":"task","doc":"Generates a PlugRest resource in your Phoenix application. mix phx_rest.gen.resource UserResource The generator will add the following files to lib/: a resource file in lib/my_app_web/resources/user_resource.ex To place the resource under lib/my_app/web instead, use the --path and --namespace options: mix phx_rest.gen.resource UserResource --path &quot;lib/my_app/web/resources&quot; --namespace MyApp.Web To create a resource with no tutorial comments: mix phx_rest.gen.resource UserResource --no-comments"},{"ref":"Mix.Tasks.PhxRest.Gen.Resource.html#no_umbrella!/1","title":"Mix.Tasks.PhxRest.Gen.Resource.no_umbrella!/1","type":"function","doc":"Raises on umbrella application."},{"ref":"Mix.Tasks.PhxRest.Gen.Resource.html#run/1","title":"Mix.Tasks.PhxRest.Gen.Resource.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"PhoenixRest.html","title":"PhoenixRest","type":"module","doc":"This is the documentation for the PhoenixRest project. PhoenixRest makes the PlugRest library available for direct use in a Pheonix router, by adding a resource macro which dispatches requests to handler modules implementing REST semantics via a series of optional callbacks. For more information see: PlugRest - an Elixir port of Cowboy&#39;s REST sub-protocol for Plug applications Phoenix - a productive web framework that does not compromise speed and maintainability."},{"ref":"PhoenixRest.Resource.html","title":"PhoenixRest.Resource","type":"module","doc":"Define callbacks and REST semantics for a Resource behaviour Based on Cowboy&#39;s cowboy_rest module. It operates on a Plug connection and a handler module which implements one or more of the optional callbacks. For example, the route: resource &quot;/users/:username&quot;, MyApp.UserResource will invoke the init/2 function of MyApp.UserResource if it exists and then continue executing to determine the state of the resource. By default the resource must implement a to_html content handler which returns a &quot;text/html&quot; representation of the resource. defmodule MyApp.UserResource do use PhoenixRest.Resource def init(conn, state) do {:ok, conn, state} end def allowed_methods(conn, state) do {[&quot;GET&quot;], conn, state} end def resource_exists(%{params: params} = conn, _state) username = params[&quot;username&quot;] # Look up user state = %{name: &quot;John Doe&quot;, username: username} {true, conn, state} end def content_types_provided(conn, state) do {[{&quot;text/html&quot;, :to_html}], conn, state} end def to_html(conn, %{name: name} = state) do {&quot;&lt;p&gt;Hello, \#{name}&lt;/p&gt;&quot;, conn, state} end end Each callback accepts a %Plug.Conn{} struct and the current state of the resource, and returns a three-element tuple of the form {value, conn, state}. The resource callbacks are named below, along with their default values. Some functions are skipped if they are undefined. Others have no default value. allowed_methods : [&quot;GET&quot;, &quot;HEAD&quot;, &quot;OPTIONS&quot;] allow_missing_post : true charsets_provided : skip content_types_accepted : none content_types_provided : [{{&quot;text&quot;, &quot;html&quot;, %{}}, :to_html}] delete_completed : true delete_resource : false expires : nil forbidden : false generate_etag : nil is_authorized : true is_conflict : false known_methods : [&quot;GET&quot;, &quot;HEAD&quot;, &quot;POST&quot;, &quot;PUT&quot;, &quot;PATCH&quot;, &quot;DELETE&quot;, &quot;OPTIONS&quot;] languages_provided : skip last_modified : nil malformed_request : false moved_permanently : false moved_temporarily : false multiple_choices : false options : :ok previously_existed : false resource_exists : true service_available : true uri_too_long : false valid_content_headers : true valid_entity_length : true variances : [] You must also define the content handler callbacks that are specified through content_types_accepted/2 and content_types_provided/2. It is conventional to name the functions after the content types that they handle, such as from_html and to_html. The handler function which provides a representation of the resource must return a three element tuple of the form {body, conn, state}, where body is one of: binary(), which will be sent with send_resp/3 {:chunked, Enum.t}, which will use send_chunked/2 {:file, binary()}, which will use send_file/3 You can halt the resource handling from any callback and return a manual response like so: response = send_resp(conn, status_code, resp_body) {:stop, response, state} The content accepted handlers defined in content_types_accepted will be called for POST, PUT, and PATCH requests. By default, the response body will be empty. If desired, you can set the response body like so: conn2 = put_rest_body(conn, &quot;\#{conn.method} was successful&quot;) {true, conn2, state} More Information The documentation for PlugRest.Resource has more details."},{"ref":"PhoenixRest.Router.html","title":"PhoenixRest.Router","type":"module","doc":"A DSL to supplement Phoenix Router with a resource-oriented routing algorithm. It provides a macro to generate routes that dispatch to specific resource handlers. Edit web/web.ex and add the router: def router do quote do use Phoenix.Router use PhoenixRest.Router end end Then use the resource macro in your router to match a path with a resource handler: defmodule MyApp.Router do use HelloPhoenix.Web, :router resource &quot;/pages/:page&quot;, PageResource end The resource/4 macro accepts a request of format &quot;/pages/VALUE&quot; and and dispatches it to PageResource, which must be a Plug module. See PhoenixRest.Resource for information on how to write a Plug module that implements REST semantics. Routes resource &quot;/hello&quot;, HelloResource The example above will route any requests for &quot;/hello&quot; to the HelloResource module. A route can also specify parameters which will be available to the resource: resource &quot;/hello/:name&quot;, HelloResource The value of the dynamic path segment can be read inside the HelloResource module: def to_html(%{params: params} = conn, state) do %{&quot;name&quot; =&gt; name} = params {&quot;Hello \#{name}!&quot;, conn, state} end"},{"ref":"PhoenixRest.Router.html#resource/4","title":"PhoenixRest.Router.resource/4","type":"macro","doc":"Main API to define resource routes. It accepts an expression representing the path, a Plug module, the options for the plug, and options for the macro. Examples resource &quot;/path&quot;, PlugModule, plug_opts, options Options resource/4 accepts the same options as PhoenixRouter.match/5"},{"ref":"readme.html","title":"PhoenixRest","type":"extras","doc":"PhoenixRest Resource routing and REST behaviour for Phoenix web applications. PhoenixRest integrates the PlugRest library into your Phoenix application by making a new resource macro available in the existing router. Instead of writing a Phoenix Controller and implementing an action function for each HTTP verb and path, use this library to create a Resource and define one or more optional callbacks that describe your resource&#39;s RESTful behavior. Documentation for PhoenixRest is available on hexdocs. Source code is available on Github. Package is available on hex."},{"ref":"readme.html#hello-world","title":"PhoenixRest - Hello World","type":"extras","doc":"Add a new route to your router to match a path with a resource handler: defmodule HelloPhoenix.Router do use HelloPhoenix.Web, :router resource &quot;/hello&quot;, HelloPhoenix.HelloResource end Create a resource at web/resources/hello_resource.ex defining the resource handler, and implement the optional callbacks: defmodule HelloPhoenix.HelloResource do use PhoenixRest.Resource def to_html(conn, state) do {&quot;Hello world&quot;, conn, state} end end The docs for PhoenixRest.Resource list all of the supported REST callbacks and their default values."},{"ref":"readme.html#installation","title":"PhoenixRest - Installation","type":"extras","doc":"Add PhoenixRest to your Phoenix project in three steps: Add :phoenix_rest to your list of dependencies in mix.exs: def deps do [{:phoenix_rest, &quot;~&gt; 0.6&quot;}] end Ensure phoenix_rest is started before your application: def application do [applications: [:phoenix_rest]] end Edit web/web.ex and add the router: def router do quote do use Phoenix.Router use PhoenixRest.Router end end"},{"ref":"readme.html#tasks","title":"PhoenixRest - Tasks","type":"extras","doc":"You can generate a new PhoenixRest resource (with all of the callbacks implemented) by using a Mix task: mix phx_rest.gen.resource UserResource"},{"ref":"readme.html#upgrading","title":"PhoenixRest - Upgrading","type":"extras","doc":"PhoenixRest is still in an initial development phase. Expect breaking changes at least in each minor version. See the CHANGELOG for more information."},{"ref":"readme.html#license","title":"PhoenixRest - License","type":"extras","doc":"PhoenixRest copyright &copy; 2016, Christopher Adams"}]